﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace Etapa1.Import
{
    public struct VertexPositionNormalTextureIndiceWeight
    {
        public Vector3 Position;
        public Vector3 Normal;
        public Vector2 TextureCoordinate;
        public Vector4 BlendWeight;
        public Vector4 BlendIndices;

        public static readonly VertexElement[] VertexElements =
        new VertexElement[]
        {
        new VertexElement(0, 0, VertexElementFormat.Vector3, VertexElementMethod.Default, VertexElementUsage.Position, 0),
        new VertexElement(0, sizeof(float) * 3, VertexElementFormat.Vector3, VertexElementMethod.Default, VertexElementUsage.Normal, 0),
        new VertexElement(0, sizeof(float) * 6, VertexElementFormat.Vector2, VertexElementMethod.Default, VertexElementUsage.TextureCoordinate, 0),
        new VertexElement(0, sizeof(float) * 8, VertexElementFormat.Vector4, VertexElementMethod.Default, VertexElementUsage.BlendWeight, 0),
        new VertexElement(0, sizeof(float) * 12, VertexElementFormat.Vector4, VertexElementMethod.Default, VertexElementUsage.BlendIndices, 0),
    };
        public VertexPositionNormalTextureIndiceWeight(Vector3 position, Vector3 normal, Vector2 textureCoordinate, Vector4 BlendWeight, Vector4 BlendIndices)
        {
            Position = position;
            Normal = normal;
            TextureCoordinate = textureCoordinate;
            this.BlendWeight = BlendWeight;
            this.BlendIndices = BlendIndices;
        }
        public static int SizeInBytes { get { return sizeof(float) * 16; } }
    }
}
