﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Etapa1.SofRender
{
    public class TextureShader : SEffect,PixelShader,VertexShader
    {
        public TextureShader()
        {
            this.GeometricShader = null;
            this.PixelShader = this;
            this.VertexShader = this;
        }

        Matrix world;

        public Matrix World
        {
            get { return world; }
            set { world = value; }
        }
        Matrix view;

        public Matrix View
        {
            get { return view; }
            set { view = value; }
        }
        Matrix projection;

        public Matrix Projection
        {
            get { return projection; }
            set { projection = value; }
        }        

        public Texture2D Difuse
        {
            set { sampler = TextureSampler.Sampler(value,Mode.CLAMP,InterpolationMode.BILINEAR);  }
        }

        TextureSampler sampler;

        #region VertexShader Members

        VertexType VertexShader.VertexShader(VertexType vertice)
        {
            Vector4 pos = vertice[Slots.POSITION0]; 
            pos = Vector4.Transform(pos, World);
            pos = Vector4.Transform(pos, view);
            pos = Vector4.Transform(pos, projection);

            Vector4 normal = vertice[Slots.NORMAL0];
            normal = Vector4.Transform(pos, World);            

            VertexType output = new VertexType();
            output[Slots.POSITION0] = pos;
            output[Slots.TEXTCOORD0] = vertice[Slots.TEXTCOORD0];
            output[Slots.NORMAL0] = normal;            
            return output;
        }

        #endregion

        #region PixelShader Members

        Color PixelShader.PixelShader(VertexType vo)
        {
            Vector4 vec = vo[Slots.TEXTCOORD0];
            if (vec.X > 1 || vec.X < 0 )
            {
            }
            return sampler.Text2D(vo[Slots.TEXTCOORD0]);
            
        }

        #endregion
    }
}
