﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using PloobsEngine;
using PloobsEngine.SceneControl;
using PloobsEngine.Utils;
using Etapa1.SofRender;
using System.Collections.Generic;
using ModelXML;
using PloobsEngine.Cameras;
using Etapa1.Import;
using Etapa1.SofRender.Sample;

namespace Etapa1.Screens
{
    public class SoftLightScreen : IScreen
    {
        public SoftLightScreen()
            : base()
        {
        }

        Device device ;
        CameraStatic camera;
        List<SModelo> modelos = new List<SModelo>();

        public override void LoadContent(EngineStuff es)
        {
            device = new Device();
            Cena cena = Cena.LoadXmlContent("Content//cam.xml");

            foreach (var item in cena.Modelos)
            {                
                SModelo m = new SModelo(item);
                SimpleLightingShader ts = new SimpleLightingShader();
                ts.vLightDirection = -Vector4.UnitX;                
                m.Effect = ts;
                modelos.Add(m);
            }

            List<CameraStatic> cameras = new List<CameraStatic>();
            foreach (var item in cena.Cameras)
            {
                CameraStatic cs = new CameraStatic(ImporterHelper.toVector3(item.Position), ImporterHelper.toVector3(item.Target));
                //cs.FieldOfView = item.Fov;
                cs.NearPlane = item.NearPlane;
                cs.FarPlane = item.FarPlane;
                cs.Name = item.Name;
                cameras.Add(cs);
            }
            camera = cameras[0];

            base.LoadContent(es);
        }

        public override void Update(GameTime gameTime, bool otherScreenHasFocus, bool coveredByOtherScreen)
        {
            device.Clear(Color.Red, 1);
            
            foreach (var item in modelos)
            {
                SimpleLightingShader bs = (item.Effect as SimpleLightingShader);
                bs.matWorldViewProj = item.World * camera.View * camera.Projection;
                bs.matWorld = item.World;
                bs.EyePos = ShaderOp.toVector4(camera.Position);
                device.SetEffect(item.Effect);
                device.SetIndexBuffer(item.Indices);
                device.SetVertexBuffer(item.VertexType);
                device.DrawIndexedPrimitive(PrimitivesType.TriangleList);                
            }           
            
            base.Update(gameTime, otherScreenHasFocus, coveredByOtherScreen);
        }

        public override void Draw(GameTime gameTime)
        {
            device.Draw();
            base.Draw(gameTime);

        }
    }
        
}

